#pragma once

// Author: Thomas Braun thomas dott braun ht virtuell - zuhause dott de

// Custom error codes
#define OLD_IGOR       1 + FIRST_XOP_ERR
#define MISSING_PARAMS 2 + FIRST_XOP_ERR
#define OLD_INDEX      3 + FIRST_XOP_ERR

// Operation template: UpdateIndex

// Runtime param structure for UpdateIndex operation.
#pragma pack(2)	// All structures passed to Igor are two-byte aligned.
struct UpdateIndexRuntimeParams {
	// Flag parameters.

	// Main parameters.

	// These are postamble fields that Igor sets.
	int calledFromFunction;					// 1 if called from a user function, 0 otherwise.
	int calledFromMacro;					// 1 if called from a macro, 0 otherwise.
};
typedef struct UpdateIndexRuntimeParams UpdateIndexRuntimeParams;
typedef struct UpdateIndexRuntimeParams* UpdateIndexRuntimeParamsPtr;
#pragma pack()	// Reset structure alignment to default.

extern "C" int ExecuteUpdateIndex(UpdateIndexRuntimeParamsPtr p);

// Operation template: FetchWave /L=string:wvName /DEST=DataFolderAndName:{wv,wave}

// Runtime param structure for FetchWave operation.
#pragma pack(2)	// All structures passed to Igor are two-byte aligned.
struct FetchWaveRuntimeParams {
	// Flag parameters.

	// Parameters for /L flag group.
	int LFlagEncountered;
	Handle wvName;
	int LFlagParamsSet[1];

	// Parameters for /DEST flag group.
	int DESTFlagEncountered;
	DataFolderAndName wv;
	int DESTFlagParamsSet[1];

	// Main parameters.

	// These are postamble fields that Igor sets.
	int calledFromFunction;					// 1 if called from a user function, 0 otherwise.
	int calledFromMacro;					// 1 if called from a macro, 0 otherwise.
};
typedef struct FetchWaveRuntimeParams FetchWaveRuntimeParams;
typedef struct FetchWaveRuntimeParams* FetchWaveRuntimeParamsPtr;
#pragma pack()	// Reset structure alignment to default.

extern "C" int ExecuteFetchWave(FetchWaveRuntimeParamsPtr p);


HOST_IMPORT int main(IORecHandle ioRecHandle);
